//@comp
//  cv graph.cpp maxflow.cpp graph.h block.h alpha_stereo.cpp -o alpha 

#define _DEBUG

#include <stdio.h>
#include<stdlib.h>
#include "graph.h"
#include<cv.h>
#include<highgui.h>
#include<cxcore.h>
#include<vector>
#include<time.h>

#define COST 1
#define CONST 1

#define E 1000000000
#define MAX(a,b) ( (a) > (b) ? (a) : (b))
#define INF 10000
#define DISPMAX 16

#define WINSIZE 3
#define sqr(a) ( (a)*(a) )

#define TH 100
#define CON0 1
#define CON1 4

#define LEFT 0
#define UP 1
#define RIGHT 2
#define DOWN 3



using namespace std;

typedef unsigned char uchar;
int height_k;
int width_k ;
IplImage* img_l;
IplImage* img_r;



////////////////////////////////////
// f[^RXg
///////////////////////////////////
int data_c(int x, int y, int disp){

  int sum = 0;
  int count = 0;

  for(int i = -WINSIZE; i <= WINSIZE; i++){
    for(int j = -WINSIZE; j <= WINSIZE; j++){
      if( ((x +j) > width_k) || ((x +j) < 0) ){continue;}
      if( ((j +i) > height_k) || ((y +i) < 0) ){continue;}
      count++;
      int idx1 = (x +j) + width_k * (y +i);
      int idx2 = (x +j -disp) + width_k * (y +i);
      /*SAD*/
      sum += abs( img_l->imageData[idx1] - img_r->imageData[idx2]);
      /*SSD*/
     //  sum += ( img_l->imageData[idx1] - img_r->imageData[idx2])
// 	     *( img_l->imageData[idx1] - img_r->imageData[idx2]);
    }
  }
  return sum ;
  
}


/////////////////////////////
//X[YRXg
/////////////////////////////
inline int smooth_c(uchar p, uchar q, double c){

  return ( c * abs( int(p - q) ) );

}

////////////////////////////
//m[h̃CfbNX擾
///////////////////////////
inline int pix_idx(int x, int y){

  return ( (3*width_k-1)* y ) + ( 2 * x ); 

}

///////////////////////////
//߂l w
///////////////////////////
inline int pix_neighbor(int x, int y, int d){
 
  switch(d){
  case 0: //
    return ( pix_idx(x,y)-1 );
    break;
  case 1: //
    return ( pix_idx(x,y) - (width_k + x));
    break;
  case 2: //E
    return ( pix_idx(x,y)+1 );
    break;
  case 3: //
    return ( pix_idx(x,y) + ((2*width_k-1) - x) );
    break;
  default:
    return -1;
    break;
  }
}

////////////////////////////////////
//xɋ߂lԂ
////////////////////////////////////
int near_label(uchar label,std::vector<int>alpha){

  int tmp;
  int min = 255;
  int idx = 0;
  for(int i =0; i <alpha.size(); i++){
    tmp = alpha[i] - label;

    tmp = abs(tmp);
      if(min > tmp ){
      min = tmp;
      idx = i;
    }
  }

  return alpha[idx];
}


/////////////////////////
//C֐
////////////////////////
int main(int argc, char* argv[])
{

  clock_t start,end;
  /*̐*/
  if(argc != 4){
    fprintf(stderr,"%d\n",argc);
    fprintf(stderr,"%s Left_filename Right_filename Result_filename\n",argv[0]);
    return -1;
  }


  /*OCXP[œǂݍ*/
  img_l = cvLoadImage(argv[1],CV_LOAD_IMAGE_GRAYSCALE);
  if(img_l == NULL){
    fprintf(stderr,"No input left... \n");
    return -1;
  }
  img_r = cvLoadImage(argv[2],CV_LOAD_IMAGE_GRAYSCALE);
  if(img_r == NULL){
    fprintf(stderr,"No input right...\n");
    return -1;
  }

  /*Kwx̌vZ*/
//   int tom =DISPMAX;
//   int tmp = DISPMAX;
//   int count = 0;

//   for(int i = 0; i < 100; i++){
//     if( tmp == 1){
//       break;
//     }
//     tmp = tmp / 2;
//     count++;
//   }
//   int count2 = ( count * 2) + 1;

//   vector< vector<int> > a;

//   a.resize(count2);

//   a[0].resize(1);
//   a[0][0] = 0;
//   a[1].resize(1);
//   a[1][0] = tom/2;
  
//   for(int k = 1; k < count; k++){

//     int array_size = pow(2,(k-1)) ;
  
//     a[2 * k].resize( array_size );
//     a[2 * k +1].resize( array_size );

//     for(int j = 0; j < array_size; j++){

//       a[2 * k][j] = ((1 + 4 * j) / ( pow(2, k+1) ) ) * tom;
//       a[2 * k +1][j] = ((3 + 4 * j) / ( pow(2, k+1) ) ) * tom;

//     }
//   }

  /*摜TCY*/
  int height = img_l->height;
  int width = img_l->width;
  height_k = img_l->height;
  width_k = img_l->width;

  /*GbWCm[h*/
  int edge_num = ((height-1) *(width)) + ((height) * (width-1)) * 2;
  int node_num =  (width * height) 
    + ((width-1) * (height)) 
    + ((width) * (height-1));

  typedef Graph<int,int,int> GraphType;

  /**/
  uchar f[width * height];
  /*̒l*/
//uchar alpha[width * height];
  /*ԌvJn*/
  start = clock();
  /*l*/
  for(int p = 0; p < width * height; p++){
    f[p] = 0;
  }


  long int e = E;
  int success = 0;



 //  double con;
//   int d;
  for(int n = 0; n < 1000; n++){

    success = 0;

    for(int alpha = 0; alpha < DISPMAX ; alpha++){
      /*Ot̏*/
      GraphType *g = new GraphType( node_num,  edge_num );
      /*m[h̒ǉ */
      g -> add_node(node_num);

     /*\[XEVNւ̏dݐݒ*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){
	  //ꎟz̃CfbNX
	  int pix_num = i + width*j;
	  //m[h̃CfbNX
	  int tmp_num = pix_idx(i,j);

	  //alpha[pix_num] = near_label( f[pix_num], a[al]);
	  

	  /*f[^RXgݒ*/
	  g -> add_tweights( tmp_num,data_c(i,j,f[pix_num]), data_c(i,j,alpha) );
	}

      }

      int weight = 0;
      double con = CONST;
     
      int d = 0;
      
      /*GbW̏dݐݒ*/
      for(int j = 0; j < height; j++){
	for(int i = 0; i < width; i++){

	  // int e_pa,e_ap,e_qa,e_aq;

	  if( i != (width-1) ){
	    d = abs(img_l->imageData[i+j*width] - img_l->imageData[i+j*width +1]);

	    /*
	    if( smooth_c( f[i+j*width], f[i+j*width +1], con) < smooth_c( alpha[i+j*width], alpha[i+j*width +1], con)){

	      e_pa = MAX( 0 , (smooth_c(alpha[i+j*width], f[i+j*width +1], con) - smooth_c( f[i+j*width], f[i+j*width +1], con) ) );
	      e_ap = INF;
	      e_qa = MAX( 0 , (smooth_c(alpha[i+j*width +1], f[i+j*width], con) - smooth_c( f[i+j*width], f[i+j*width +1], con) ) );
	      e_aq = INF;

	    }else{

	      e_ap = MAX( 0 , (smooth_c(alpha[i+j*width +1], f[i+j*width], con) - smooth_c( alpha[i+j*width], alpha[i+j*width +1], con) ) );
	      e_pa = INF;
	      e_aq = MAX( 0 , (smooth_c(alpha[i+j*width], f[i+j*width +1], con) - smooth_c( alpha[i+j*width], alpha[i+j*width +1], con) ) );
	      e_qa = INF;

	    }
 
	  
	    g -> add_edge( pix_idx(i ,j),pix_neighbor(i,j,RIGHT), e_pa, e_ap);
	    g -> add_edge( pix_neighbor(i,j,RIGHT), pix_idx(i+1 ,j),e_aq, e_qa );
	    */

	    int fpalpha = smooth_c(f[i+j*width] , alpha , con);
	    int fqalpha = smooth_c(f[i+j*width + 1] , alpha , con);


	    g -> add_edge( pix_idx(i ,j),pix_neighbor(i,j,RIGHT), fpalpha, fpalpha);
	    g -> add_edge( pix_neighbor(i,j,RIGHT), pix_idx(i+1 ,j), fqalpha, fqalpha);




	    //ԃm[h̃VNV(alpha,alpha)ƃ\[XV(fp,fq)ւ̃RXgݒ
	    g -> add_tweights( pix_neighbor(i,j,RIGHT),
			       smooth_c(f[i+j*width],f[i+j*width +1],con), 
			       smooth_c(alpha,alpha,con) );
	    /*
	      g -> add_tweights( pix_neighbor(i,j,RIGHT),
	                       smooth_c(f[i+j*width],f[i+j*width +1],con), 
			       smooth_c(alpha[i+j*width],alpha[i+j*width +1],con) );
	    */
	  }






	  if( j != (height-1) ){

	    d = abs(img_l->imageData[i+j*width] - img_l->imageData[i+(j +1)*width]);

	    /*
	    if( smooth_c( f[i+j*width], f[i+(j+1)*width], con) < smooth_c( alpha[i+j*width], alpha[i+(j+1)*width], con)){

	      e_pa = MAX( 0 , (smooth_c(alpha[i+j*width], f[i+(j+1)*width], con) - smooth_c( f[i+j*width], f[i+(j+1)*width], con) ) );
	      e_ap = INF;
	      e_qa = MAX( 0 , (smooth_c(alpha[i+(j+1)*width], f[i+j*width], con) - smooth_c( f[i+j*width], f[i+(j+1)*width], con) ) );
	      e_aq = INF;

	    }else{

	      e_ap = MAX( 0 , (smooth_c(alpha[i+(j+1)*width], f[i+j*width], con) - smooth_c( alpha[i+j*width], alpha[i+(j+1)*width], con) ) );
	      e_pa = INF;
	      e_aq = MAX( 0 , (smooth_c(alpha[i+j*width], f[i+(j+1)*width], con) - smooth_c( alpha[i+j*width], alpha[i+(j+1)*width], con) ) );
	      e_qa = INF;

	    }
	    

	    g -> add_edge( pix_idx(i ,j),pix_neighbor(i,j,DOWN), e_pa, e_ap);
	    g -> add_edge( pix_neighbor(i,j,DOWN), pix_idx(i ,j +1),e_aq, e_qa );
	    */

	    int fpalpha = smooth_c(f[i+j*width] , alpha , con);
	    int fqalpha = smooth_c(f[i+(j+1)*width] , alpha , con);

	    g -> add_edge( pix_idx(i ,j),pix_neighbor(i,j,DOWN), fpalpha, fpalpha);
	    g -> add_edge( pix_neighbor(i,j,DOWN), pix_idx(i ,j +1), fqalpha , fqalpha );
	    


	    //ԃm[h̃VNV(alpha,alpha)ƃ\[XV(fp,fq)ւ̃RXgݒ
	    g -> add_tweights( pix_neighbor(i,j,DOWN),
			       smooth_c(f[i+j*width],f[i+(j+1)*width],con), 
			       smooth_c(alpha,alpha,con) );
	    /*
	      g -> add_tweights( pix_neighbor(i,j,DOWN),
			       smooth_c(f[i+j*width],f[i+(j+1)*width],con), 
			       smooth_c(alpha[i+j*width],alpha[i+(j+1)*width],con) );
	    */

	  }

	}
      }


      //ő嗬EŏJbgASY
      int flow = g -> maxflow();

      if(flow < e){
	fprintf(stderr,"Flow = %d\n", flow);

	/*xύX*/
	for(int k =0; k < height ; k++){
	  for(int m =0; m < width ; m++){

	    int pix_num = m + width*k;
	    int tmp_num = pix_idx(m,k);

	    if (g->what_segment(tmp_num) == GraphType::SOURCE){
	      //alphaɕύX
	      f[pix_num] = alpha;

	    }else{
    
	    }
	  }
	}
	e = flow;
	success = 1;

      }
      delete g;
    }
  
    if(success == 0){
      break;

    }
  }
  /*ԌvI*/
  end =clock();

  fprintf(stderr,"%f [s]\n",(double)(end-start)/CLOCKS_PER_SEC);
  /*摜o*/
  IplImage* result;
  result = cvCreateImage(cvGetSize(img_l),IPL_DEPTH_8U,1);
  for(int i = 0; i < (width * height); i++){

      result->imageData[i] = f[i] * 16;

  }


#ifdef _DEBUG
  cvNamedWindow("result",CV_WINDOW_AUTOSIZE);
  cvShowImage("result",result);
  cvNamedWindow("Image-left",CV_WINDOW_AUTOSIZE);
  cvShowImage("Image-left",img_l);
  cvNamedWindow("Image-right",CV_WINDOW_AUTOSIZE);
  cvShowImage("Image-right",img_r);

  cvWaitKey(0);
  cvSaveImage(argv[3],result);
#else
  cvSaveImage(argv[3],result);
#endif

  cvReleaseImage(&img_l);
  cvReleaseImage(&img_r);
  cvReleaseImage(&result);

  return 0;
}

